<?php
if (!class_exists('System')) exit; // Запрет прямого доступа

$newsStorage = new EngineStorage('module.news2');

if($act=='index'){
	echo'<div class="header"><h1>Обновление</h1></div>
	<div class="menu_page"><a href="index.php">&#8592; Вернуться назад</a></div>
	<div class="content">
	<a href="module.php?module=update&amp;act=update" class="button">Начать обновление данных</a>
	</div>';
}

if($act=='update'){
	echo'<div class="header"><h1>Обновление</h1></div>
	<div class="menu_page"><a href="module.php?module=update">&#8592; Вернуться назад</a></div>
	<div class="content">
	<div class="box">
	Начало сканирования! Прочитайте все что будет выводится ниже и если будут ошибки сообщите об этом в поддержку движка<br><br>';
	if (@System::listPages() == false){
		echo'Обновление страниц сайта<br>';
		$arr_file = file(DR.'/data/pages/list.dat', FILE_IGNORE_NEW_LINES | FILE_SKIP_EMPTY_LINES);
		file_put_contents(DR.'/data/pages/list.dat', json_encode($arr_file));
		echo'Список обновленных страниц: ';
		echo implode(', ',$arr_file).'<br>';
		echo'Завершение обновления страниц сайта<br><br>';
	}else {
		echo'Обновление страниц сайта не требуется<br><br>';
	}
	


	



	echo'Проверка наличия новостей в старом модуле новостей и попытка обновления данных для новой версии<br>';
	$arr_file = @file(DR.'/modules/news2/data/list.dat', FILE_IGNORE_NEW_LINES | FILE_SKIP_EMPTY_LINES);
	$nom = count($arr_file);
	if($nom == 0){
		echo'Новостей нет<br>';
	}else{
			foreach($arr_file as $id){
				
					$cfg_news = explode('<||>', file_get_contents(DR.'/modules/news2/data/header_news_'.$id.'.dat'));
					

					// echo'id - '.$id.'<br>';
					// echo'Заголовок - '.$cfg_news[0].'<br>';
					// echo'keywords - '.$cfg_news[1].'<br>';
					// echo'description - '.$cfg_news[2].'<br>';
					// echo'comments - '.$cfg_news[3].'<br>';
					// echo'date_news - '.$cfg_news[4].'<br>';
					// echo'prev - '.file_get_contents(DR.'/modules/news2/data/prev_news_'.$id.'.dat').'<br>';
					// echo'content - '.file_get_contents(DR.'/modules/news2/data/content_news_'.$id.'.dat').'<br>';
					

					$param['header'] = $cfg_news[0];
					$param['keywords'] = $cfg_news[1];
					$param['description'] = $cfg_news[2];
					$param['img'] = '/modules/news/default.jpg';
					$param['prev'] = file_get_contents(DR.'/modules/news2/data/prev_news_'.$id.'.dat');
					$param['content'] = file_get_contents(DR.'/modules/news2/data/content_news_'.$id.'.dat');
					$param['date'] = $cfg_news[4];
					$param['comments'] = $cfg_news[3];
					
					echo'Добавлена новость с заголовком: '.$param['header'].'<br>';
					
					if($newsStorage->set('news_'.$id, json_encode($param))){
						
						// Добавляем ID новости в список
						$listIdNews = json_decode($newsStorage->get('list'), true); // Получили список ввиде массива
						$listIdNews[] = $id;// Добавили новый элемент массива в конец
						$newsStorage->set('list', json_encode($listIdNews)); // Записали массив в виде json
						
						
						System::notification('Добавлена новость с заголовком: '.$param['header']);
						
					}
			}
	}
	echo'Завершение обновления новостей. Было обновлено '.$nom.' новостей<br><br>';

	echo'Удаление старого модуля новостей и его данных<br><br>';
	@Module::delete('news2');
	
	echo'Начало проверки на наличие старых шаблонов и попытка их обновить для совместимости с новой версией движка<br>';
	$listModules = System::listModules();
	foreach($listModules as $value){
		if(file_exists(DR.'/modules/'.$value.'/template.dat')){
			$htmlsrc = file_get_contents(DR.'/modules/'.$value.'/template.dat');

			$htmlsrc = str_replace('$page->', '$Page->', $htmlsrc);
			$htmlsrc = str_replace('$value_url', '$URI', $htmlsrc);
			
			echo 'Шаблон "'.$value.'" - обновлен<br>';

			file_put_contents(DR.'/modules/'.$value.'/template.php', $htmlsrc);
			unlink(DR.'/modules/'.$value.'/template.dat');
			rename(DR.'/modules/'.$value.'/info.dat', DR.'/modules/'.$value.'/info.ini');
		}

	}
	echo'Завершение обновлений<br>';
echo'</div>
<div class="box">
<strong>Если все прошло удачно, то больше этот модуль не запускайте.</strong>
</div>
<a href="index.php" class="button">Завершить обновление</a>
</div>';

}

?>